#include <iostream>
#include <math.h>
#include <stdint.h>
#include <vector>
#include "EM_algorithm.h"
#include "maskDNA.h"
#include <bitset>
#include "peak_caller.h"
#include <ctime>
#include "ebwt_search.h"

using namespace std;

int n;
int m;
vector<uint16_t> tag_count_array;
vector<uint32_t> redundant_watson;
vector<uint32_t> redundant_crick;
vector<int> DNA_shape;
vector<int> frag_bin;
vector<string> Chr_list;
vector<int>EM_data(1,0);
vector<int>d;
int number_of_islands=0;
uint64_t count_chr1=0;
int frag_len;
int countChiP=0;
int countControl=0;
int countControlph1=0;
int ChIP=0;
int PHASE1ChIPRed=0;
int PHASE1ControlRead=0;
int redundant=0;
int WatsonReads=0;
int CrickReads=0;
//int first=1;

int LookUptable[256]={0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,
                      1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
                      1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
                      1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
                      2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
                      3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
                      3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
                      4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8};

int reverse_LookUptable[256]={0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,
                            240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,
                            248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,
                            244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,
                            252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,
                            242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,
                            250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,
                            246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,
                            254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,
                            241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,
                            249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,
                            245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,
                            253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,
                            11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,
                            135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,
                            143,79,207,47,175,111,239,31,159,95,223,63,191,127,255};


uint8_t *tags_watson=NULL;
uint8_t *tags_crick=NULL;
uint8_t *tags_watson_control=NULL;
uint8_t *tags_crick_control=NULL;
uint8_t *tags_watson_chr1=NULL;
uint8_t *tags_crick_chr1=NULL;


void number_of_bins(const int &DNA_len, const int &tot_chr, const int &frag_bin_len)
{
    n=DNA_len;
    m=tot_chr;
    DNA_shape.resize(m);
    Chr_list.resize(m);
    frag_bin.resize(m);
    tags_watson=new uint8_t[DNA_len]();
    tags_crick=new uint8_t[DNA_len]();
    //tags_watson_control=new uint8_t[DNA_len]();
    //tags_crick_control=new uint8_t[DNA_len]();
    tag_count_array.resize(frag_bin_len);
    //cout<<DNA_len<<"\tDNA_len"<<endl;
    //cout<<frag_bin_len<<"\tDNA_len"<<endl;
}

void ControlArray(const int &DNA_len)
{
    tags_watson_control=new uint8_t[DNA_len]();
    tags_crick_control=new uint8_t[DNA_len]();
    //cout<<"ControlArray\t"<<DNA_len<<endl;
}

void EM_genomic_coord(const unsigned int &gc, const int &chrid, const bool &strand)
{
  /* if(control==true && first==1){
          int count_watson=0;
          int count_crick=0;
          for (int i=0; i<386961748; i++){
          count_watson=count_watson+ LookUptable[tags_watson[i]];
          count_crick=count_crick+ LookUptable[tags_crick[i]];
          if(i==386961747){
          cout<<"Printing\t"<<count_watson<<"\t"<<count_crick<<endl;
          }
        }

    first=2;
    }*/

    if(PHASE_2==false && control==false){
     countChiP=countChiP+1;
    }

    if(control==true && controlPhase1 ==true){
    countControlph1=countControlph1+1;
    }

    if(control==true && controlPhase1== false){
    countControl=countControl+1;
    }

    if(control==false){
    ChIP=ChIP+1;
    }

    if(strand==true && control==false){
    WatsonReads=WatsonReads+1;
    }
    else if (strand==false && control==false){
    CrickReads=CrickReads+1;
    }

    bool island_found=true;
	//int subscript=ceil(float(gc)/8);
	int subscript=gc;
	if(gc%8!=0){
	subscript=subscript/8;
	subscript=subscript+1;
	}
	else{
	subscript=subscript/8;
	}
	int remainder= gc%8;
	if(remainder==0)
	{
        remainder=8;
	}
        if(chrid == 0)
        {
            count_chr1+=1;

            uint8_t mask=1;
            mask<<=8-remainder;
            if(strand==true)
            {
                    if(PHASE_2==false)
                    {
                    if((tags_watson[subscript-1]&mask)==0)
                    {

                        for(int i=gc-1; i<gc-1+READ_LEN; i++)
                        {
                        tags_watson_chr1[i]+=1;
                        }
                    }
                    else
                    {
                        PHASE1ChIPRed=PHASE1ChIPRed+1;
                        redundant_watson.push_back(gc-1);

                    }

                    for(int i=subscript-31; i<subscript+31;i++)
                    {
                        if((tags_watson[i]>0||tags_crick[i]>0)&& i!=(subscript-1) )
                        {
                        island_found=false;
                        break;
                        }

                    }
                    }
                if(control==true){
                if(controlPhase1==true && (tags_watson_control[subscript-1]&mask)!=0){
                PHASE1ControlRead=PHASE1ControlRead+1;
                }

                tags_watson_control[subscript-1]|=mask;
                }
                else{
                if((tags_watson[subscript-1]&mask)!=0){
                redundant=redundant+1;
                //cout<<"redundant\t"<<gc<<"\t"<<Chr_list[chrid]<<"\t"<<"+"<<"\t"<<subscript-1<<endl;
                }
                tags_watson[subscript-1]|=mask;
                }
            }
            else
            {
                if(PHASE_2==false)
                {
                if((tags_crick[subscript-1]&mask)==0)
                {
                    for(int i=gc-1; i<gc-1+READ_LEN; i++)
                    {
                        tags_crick_chr1[i+READ_LEN]+=1;
                    }
                }
                else
                    {
                    PHASE1ChIPRed=PHASE1ChIPRed+1;
                    redundant_crick.push_back(gc-1);
                    }

                for(int i=subscript-31; i<subscript+31;i++)
                {
                    if((tags_watson[i]>0||tags_crick[i]>0)&& i!=(subscript-1) )
                    {
                        island_found=false;
                        break;
                    }

                }
                }
                if(control==true){
                if(controlPhase1==true && (tags_crick_control[subscript-1]&mask)!=0){
                PHASE1ControlRead=PHASE1ControlRead+1;
                }

                tags_crick_control[subscript-1]|=mask;
                }
                else{
                if((tags_crick[subscript-1]&mask)!=0){
                redundant=redundant+1;
                //cout<<"redundant\t"<<gc<<"\t"<<Chr_list[chrid]<<"\t"<<"-"<<"\t"<<subscript-1<<endl;
                }
                tags_crick[subscript-1]|=mask;
                }
            }
        }
        else
        {
        subscript = DNA_shape[chrid-1]+subscript;

        uint8_t mask=1;
        mask<<=8-remainder;
            if(strand==true)
            {

                if(PHASE_2==false)
                {
                if((tags_watson[subscript-1]&mask)!=0)
                {
                PHASE1ChIPRed=PHASE1ChIPRed+1;
                redundant_watson.push_back(gc-1 +DNA_shape[chrid-1]*8);
                }
                for(int i=subscript-31; i<subscript+31;i++)
                {
                    if((tags_watson[i]>0 ||tags_crick[i]>0 )&& i!=(subscript-1) )
                    {
                        island_found=false;
                        break;
                    }

                }

                }
                if(control==true){
                if(controlPhase1==true && (tags_watson_control[subscript-1]&mask)!=0){
                PHASE1ControlRead=PHASE1ControlRead+1;
                }
                tags_watson_control[subscript-1]|=mask;
                }
                else{
                if((tags_watson[subscript-1]&mask)!=0){
                redundant=redundant+1;
                //cout<<"\tredundant\t"<<gc<<"\t"<<Chr_list[chrid]<<"\t"<<"+"<<"\t"<<subscript-1<<endl;
                }
                tags_watson[subscript-1]|=mask;
                }
            }
            else
            {


                if(PHASE_2==false)
                {
                if((tags_crick[subscript-1]&mask)!=0)
                {
                    PHASE1ChIPRed=PHASE1ChIPRed+1;
                    redundant_crick.push_back(gc-1 +DNA_shape[chrid-1]*8);
                }
                for(int i=subscript-31; i<subscript+31;i++)
                {
                    if((tags_watson[i]>0||tags_crick[i]>0)&& i!=(subscript-1) )
                    {
                        island_found=false;
                        break;
                    }
                }
                }
                if(control==true){
                if(controlPhase1==true && (tags_crick_control[subscript-1]&mask)!=0){
                PHASE1ControlRead=PHASE1ControlRead+1;
                }
                tags_crick_control[subscript-1]|=mask;
                }
                else{
                if((tags_crick[subscript-1]&mask)!=0){
                redundant=redundant+1;
                //cout<<"\tredundant\t"<<gc<<"\t"<<Chr_list[chrid]<<"\t"<<"-"<<"\t"<<subscript-1<<endl;
                }
                tags_crick[subscript-1]|=mask;
                }


            }

        }

        if(island_found==true && PHASE_2==false)
        {
            number_of_islands+=1;
        }

}

void Chr_shape(const int &chrid, const int &chrlen, const string &chrname, const int &frag_bin_length)
{
	DNA_shape[chrid]=chrlen;
	Chr_list[chrid]=chrname;
	frag_bin[chrid]=frag_bin_length;
	if(chrid==0)
	{
    //cout<<DNA_shape[0]<<endl;
	tags_watson_chr1=new uint8_t[DNA_shape[0]*8]();
    tags_crick_chr1=new uint8_t[DNA_shape[0]*8]();
	}
}

int  fragment_length()
{
        uint64_t watson_sum=0;
        uint64_t crick_sum=0;
        int optimal_shift=0;
        uint64_t  old_cross_corr=0;
        vector <int> crossCor;


   for(int d=0;d<400;d++)
   {
        uint64_t cross_correlation=0;
        for(int i=0; i<DNA_shape[0]*8-400;i++)
        {
            if(tags_watson_chr1[i]!=0 && tags_crick_chr1[i+d]!=0)
            {
            cross_correlation+=tags_watson_chr1[i]*tags_crick_chr1[i+d];
            }

        }
        if(old_cross_corr<cross_correlation && d>=2*READ_LEN)
        {
          optimal_shift=d;
          old_cross_corr=cross_correlation;
        }
        crossCor.push_back(cross_correlation);
   }


   for(int d=0;d<crossCor.size();d++)
   {

      //cout<<d<<"\td\t"<<crossCor[d]<<endl;

   }

    delete[] tags_watson_chr1;
    delete[] tags_crick_chr1;
    return optimal_shift;
}

void EM_input(int frag_len)
{
    int Number_of_bytes=ceil((double(frag_len))/8);
    int read_len_adj_up=ceil((double(READ_LEN))/8);
    int read_len_adj_down=floor((double(READ_LEN))/8);
    int p=0;
    int t=0;
    for(int k=0; k<DNA_shape.size();k++)
    {

        int count=0;

     if(k==0)
        {
            t=0;
            p=0;
        }
        else
        {
            t=DNA_shape[k-1];
            p=frag_bin[k-1];
        }
    for (int i=t; i<DNA_shape[k]-5;i++)
    {
        int start=i;
        int end=i+6;
        int Number_of_fragments=0;
        int fragments_watson=0;
        int fragments_crick=0;
        if(i<t+Number_of_bytes || i> DNA_shape[k]-Number_of_bytes)
        {
        Number_of_fragments=LookUptable[tags_watson[i]]+LookUptable[tags_watson[i+1]]
                            +LookUptable[tags_watson[i+2]]+LookUptable[tags_watson[i+3]]
                            +LookUptable[tags_watson[i+4]]+LookUptable[tags_watson[i+5]]
                            +LookUptable[tags_crick[i]]+LookUptable[tags_crick[i+1]]
                            +LookUptable[tags_crick[i+2]]+LookUptable[tags_crick[i+3]]
                            +LookUptable[tags_crick[i+4]]+LookUptable[tags_crick[i+5]];
        i=i+5;

        tag_count_array[p]+=Number_of_fragments;
        }
        else
        {
        Number_of_fragments=LookUptable[tags_watson[i]]+LookUptable[tags_watson[i+1]]
                            +LookUptable[tags_watson[i+2]]+LookUptable[tags_watson[i+3]]
                            +LookUptable[tags_watson[i+4]]+LookUptable[tags_watson[i+5]]
                            +LookUptable[tags_crick[i]]+LookUptable[tags_crick[i+1]]
                            +LookUptable[tags_crick[i+2]]+LookUptable[tags_crick[i+3]]
                            +LookUptable[tags_crick[i+4]]+LookUptable[tags_crick[i+5]];
            for(int j=start-1;j>=start-Number_of_bytes;j--)
            {
                fragments_watson+=LookUptable[tags_watson[j]];
            }
            for(int j=end;j<=end+Number_of_bytes-read_len_adj_down;j++)
            {
                fragments_crick+=LookUptable[tags_crick[j]];

            }
            for(int j=start-1;j>=start-1-read_len_adj_up;j--)
            {
                fragments_crick+=LookUptable[tags_crick[j]];

            }
        Number_of_fragments=Number_of_fragments+fragments_watson+fragments_crick;
        i=i+5;
           tag_count_array[p]+=Number_of_fragments;
        }
        if(tag_count_array[p]>=EM_data.size())
        {
            EM_data.resize(tag_count_array[p]+1);
        }
            EM_data[tag_count_array[p]]+=1;

           p+=1;
    }

    }
/*
    for(int i=0; i<redundant_watson.size();i++)
    {
        int frag_len_bins=ceil((double(frag_len))/48);
        int j=redundant_watson[i]/48;
        for(int k=j; k<frag_len_bins+j;k++)
        {
            tag_count_array[k]+=1;

        if(tag_count_array[k]>=EM_data.size())
        {
            EM_data.resize(tag_count_array[k]+1);
        }
            EM_data[tag_count_array[k]]+=1;
            EM_data[tag_count_array[k]-1]-=1;
        }

    }

    for(int i=0; i<redundant_crick.size();i++)
    {
        int frag_len_bins=ceil((double(frag_len))/48);
        int j=(redundant_crick[i]+READ_LEN)/48;
        for(int k=j; k>j-frag_len_bins;k--)
        {
            tag_count_array[k]+=1;

        if(tag_count_array[k]>=EM_data.size())
        {
            EM_data.resize(tag_count_array[k]+1);
        }
            EM_data[tag_count_array[k]]+=1;
            EM_data[tag_count_array[k]-1]-=1;
        }

    }*/

}

void EM()
{
    cerr<<endl<<"Phase 2:";
    if(FragmentLength==-1){
    cerr<<"Estimating fragment length"<<endl;
    frag_len=fragment_length();
    cerr<<"\t-->Fragment length: "<<frag_len<<endl;
    //cout<<"Estiamted fragment length\t"<<frag_len<<endl;
    }
    else{
    frag_len=FragmentLength;
     cerr<<"Fragment length: "<<frag_len<<endl;
    //cout<<"Estiamted fragment length\t"<<frag_len<<endl;
    }
    //cout<<"Estiamted fragment length\t"<<frag_len<<endl;
    EM_input(frag_len);
    cerr<<"\tPerforming Expectation Maximization algorthim"<<endl;
    int EM_cutoff=Expectation_maximization(EM_data, frag_len);
    //EM_cutoff=2;
    //cout<<"EM_cutoff\t"<<EM_cutoff<<endl;
    //cout<<"PHASE1_READs\t"<<PHASE1_READS<<endl;
    vector <int> tmp;
    vector <uint32_t> tmp1;
    EM_data.clear();
    EM_data.swap(tmp);
    redundant_crick.clear();
    redundant_crick.swap(tmp1);
    redundant_watson.clear();
    redundant_watson.swap(tmp1);
    cerr<<"\tSelecting pseudo-genome (ChIP read enriched genomic regions)"<<endl;
    Drop_regions(EM_cutoff, tag_count_array, Chr_list, frag_bin,frag_bin[m-1], m,frag_len);
    vector <uint16_t> tmp2;
    tag_count_array.clear();
    tag_count_array.swap(tmp2);
}

const vector<uint16_t>& return_tag_count()
{
    return tag_count_array;
}


const vector<string>& return_ph1_chrlist()
{
    return Chr_list;
}


const vector<int>& return_ph1_DNA_shape()
{
    return DNA_shape;
}

void return_tags()
{
    float ChIPControlScale;
    if(controlFile!=NULL){
    ChIPControlScale=(float(countChiP)-float(PHASE1ChIPRed))/(float(countControlph1)-float(PHASE1ControlRead));
    }
    else{
    ChIPControlScale=1;
    }
    send_tags(tags_watson, tags_crick, tags_watson_control, tags_crick_control, DNA_shape, Chr_list, ChIPControlScale, n);
}
