/*EM algorithm for mixture distributions.  Imagine we observe
 Y[1:n] coming from a mixture of poisson distributions.  We do not
 know which of the component distributions a given Y[i] comes from.
 We would like to estimate the parameters in all of the distributions,
 as well as the relative abundances of the distributions in the population.*/

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <boost/math/distributions.hpp>
#include <valarray>
#include <iomanip>

using namespace std;

// function to return poisson p-values based on lambda and random variable x.
double POISSON(double k, double i);

int Expectation_maximization(const vector<int> &EM_data, int frag_len);

double POISSON_quantile(double k, double i);
