#include <iostream>
#include "candidate_peak_extend.h"



/**
 * Extend a seed hit out on either side.  Requires that we know the seed hit's
 * offset into the read and orientation.  Also requires that we know top/bot
 * for the seed hit in both the forward and (if we want to extend to the right)
 * reverse index.
 */
void candidate_peak_extend(
	const Ebwt& ebwtFw,   // Forward Bowtie index
	const Ebwt* ebwtBw,   // Backward Bowtie index
	TIndexOffU topf,        // top in fw index
	TIndexOffU botf        // bot in fw index
	  )
{
		TIndexOffU top = topf, bot = botf;
		SideLocus tloc, bloc;
		const Ebwt *ebwt = &ebwtFw;
		INIT_LOCS(top, bot, tloc, bloc, *ebwt);
		for(size_t ii = 0; ii < 100; ii++) {
			// Starting to left of seed (<off) and moving left
                cout<<"top\t"<<top<<endl;
				int c = ebwt->mapLF1(top, tloc);
				cout<<"extending\t"<<c<<endl;
				bot = top + 1;
			INIT_LOCS(top, bot, tloc, bloc, *ebwt);
			}

	return;
}



