#include <iostream>
#include <math.h>
#include <stdint.h>
#include <vector>
#include "EM_algorithm.h"
#include "ebwt_search.h"
#include <string>
#include <ctime>
#include "peak_caller.h"
#include <bitset>
#include "reference.h"
#include "ref_read.h"
#include "maskDNA.h"
#include "ebwt_build.h"
#include "ebwt.h"



using namespace std;
using namespace seqan;

vector<vector <int> >  ph2_DNAshape1;
vector<vector <int> >  ph2_DNAshape2;//holds offset
vector<string> ph1_chrlist;
vector<int> DNA_shape_reindex;
vector<string> Chr_list_reindex;
void Drop_regions(const int &_cutoff, const vector<uint16_t> &tag_count, const vector<string> &Chrlist,const vector<int> &DNAshape, const int &n, const int &m, int frag_len)
{
ph1_chrlist=Chrlist;
ph2_DNAshape1.resize(m);
ph2_DNAshape2.resize(m);
//cout<<"size\t"<<ph2_DNAshape1.size()<<endl;
int cum_len=0;
int start=0;
int end=0;
int pre_end=0;
bool found=false;
bool island=false;
int j=0;
int old_j=0;
int k=0;
int chrid=0;
int old_chrid=0;
int pre_chrid;
int offset;
int remainder=0;
int sum=0;
int chk;
uint64_t totDNA=0;
string nucleotide = "ACGTN";
string DNA ="";
DNA.reserve(300000000);
frag_len =frag_len/48 +1;
static string ebwtbase= ebwtBaseLocation;
//cout<<"ebwtBaseLocation\t"<<ebwtBaseLocation<<endl;
BitPairReference *refs = NULL;
	refs = new BitPairReference(
		ebwtbase, // input basename
		false,                // true -> expect colorspace reference
		false,                // sanity-check reference
		NULL,                 // infiles
		NULL,                 // originals
		false,                // infiles are sequences
		true,                 // load sequence
		false,                // memory-map
		false,                // use shared memory
		false,
		false,
		false);

       int count=0;
    for(int j=0; j<m; j++)
    {
        int q=0;
        if(j!=0)
        {
         q=DNAshape[j-1];
        }
        else
        {
            q=0;
        }
        found=false;
        island=false;
        start=0;
        end=0;
    for(int i=q; i<DNAshape[j];i++)
    {

        if( i==DNAshape[j]-1 && found==true)
        {
                end=i;
                if(j==0)
                {
                    offset=(start-1)*48;
                    if(offset<0)
                    {
                     offset=0;
                    }
                }
                else
                {
                    offset=(start-DNAshape[j-1]-1)*48;
                    if(offset<0)
                    {
                     offset=0;
                    }
                }
                int len=(end+1-start)*48;
                totDNA=totDNA+len;
                uint32_t *buf = new uint32_t[(len*1000 + 128)/4];
                int offset1 = refs->getStretch(buf, j,offset,len);      // length to grab (exclude overhang)

                uint8_t *rf_ = (uint8_t*)buf+ offset1;

                if(ph2_DNAshape1[j].size()!=0)
                {
                    cum_len=len+ph2_DNAshape1[j][ph2_DNAshape1[j].size()-1];
                }
                else
                {
                    cum_len=len;
                }
                ph2_DNAshape1[j].push_back(cum_len);
                ph2_DNAshape2[j].push_back(offset);
                if(j>=k && remainder!=0){DNA+="\n";}
                for(int p=k;p<=j;p++){
                    if(p==j)
                    {
                    DNA+=">";
                    DNA+=Chrlist[p];
                    DNA+="\n";
                    }
                    remainder=0;
                }
                for(size_t i = 0; i < len; i++){
                        DNA+=nucleotide[(int)rf_[i]];
                        if((remainder+i+1)%48==0)
                        {
                             DNA+="\n";
                        }
                       if(i==len-1)
                        {
                            remainder=(len)%48;
                        }

                }

                i=end;
                found=false;
                island=false;
                //cout<<"1"<<endl;
                delete[] buf;
        }

       if(tag_count[i]>0 && island==false)// intializes start
        {
            start=i;
            island=true;
        }

       if(tag_count[i]>0 && found ==false)//updates start
        {
            if(i-q>frag_len)
            {
                int sum=0;
                for(int l=i-1; l>i-frag_len-1; l--)
                {
                    sum+=tag_count[l];
                }
                if(sum==0)
                {
                    start=i;
                }
            }
            island=true;
        }



        if(tag_count[i]>=_cutoff && found==false && island==true)
        {
            found=true;
        }
        else if(island==true)
        {

            if(tag_count[i]>0)
            {
                continue;
            }
            else if(found==true)
            {

                count=count+1;

                bool end_notfound=true;
                while(end_notfound==true)
                {

                    for(int l=i; l<i+frag_len; l++)
                    {
                        if(tag_count[l]>0)
                        {
                            i=l+1;
                            end_notfound=true;
                            break;
                        }
                        else
                        {
                            end_notfound=false;
                            end=l-frag_len+1;
                        }
                    }
                }

                if(j==0)
                {
                    offset=(start-1)*48;
                    if(offset<0)
                    {
                     offset=0;
                    }
                }
                else
                {
                    offset=(start-DNAshape[j-1]-1)*48;
                    if(offset<0)
                    {
                     offset=0;
                    }
                }
                int len=(end+1-start)*48;
                totDNA=totDNA+len;
                uint32_t *buf = new uint32_t[(len*1000 + 128)/4];
                int offset1 = refs->getStretch(buf, j,offset,len);// for BitPairReference::getStretch()
                uint8_t *rf_ = ((uint8_t*)buf)+ offset1;

                if(ph2_DNAshape1[j].size()!=0)
                {
                    cum_len=len+ph2_DNAshape1[j][ph2_DNAshape1[j].size()-1];
                }
                else
                {
                    cum_len=len;
                }
                ph2_DNAshape1[j].push_back(cum_len);
                ph2_DNAshape2[j].push_back(offset);
                if(j>=k && remainder!=0){DNA+="\n";}
                for(int p=k;p<=j;p++)
                {
                    if(p==j)
                    {
                    DNA+=">";
                    DNA+=Chrlist[p];
                    DNA+="\n";
                    }
                    remainder=0;
                }
                k=j+1;
                    for(size_t i = 0; i < len; i++)
                    {
                        DNA+=nucleotide[(int)rf_[i]];
                        if((remainder+i+1)%48==0)
                        {
                             DNA+="\n";
                        }
                       if(i==len-1)
                        {
                            remainder=(len)%48;
                        }
                    }

                i=end;
                found=false;
                island=false;
                //cout<<"2"<<endl;
                delete[] buf;
            }

        }
        }
    }

    cerr<<"\tPseudogenome size selected: "<<sizeof(DNA)+DNA.size()<<endl;
    DNA.resize(DNA.size());
    if(refs != NULL) {
        //cout<<"Deleting refs"<<endl;
		delete refs;
	}
    cerr<<"\tIndexing pseudogenome"<<endl;
    reindex(DNA,ebwtbase);
    DNA.clear();
    cerr<<"\tIndexing complete"<<endl;
}


void number_of_chrms_reindex( const int &tot_chr)
{
    DNA_shape_reindex.resize(tot_chr);
    Chr_list_reindex.resize(tot_chr);
}

void Chr_shape_reindex(const int &chrid, const int &chrlen, const string &chrname)
{
	DNA_shape_reindex[chrid]=chrlen;
	Chr_list_reindex[chrid]=chrname;
}


int ph2_genomic_coordinate_update(const unsigned int &offset, const int &chrid, int update[])
{
        int ph1_chrid;
        for(int i=0; i<=ph1_chrlist.size();i++)
        {
        if(ph1_chrlist[i]==Chr_list_reindex[chrid])
            {
            ph1_chrid=i;
            update[0]=i;
            break;
            }
        }
    int first=1;
    int last = ph2_DNAshape1[ph1_chrid].size();
    int mid;
    if(last==1)
    {
        update[1]=ph2_DNAshape2[ph1_chrid][0];
        return ph2_DNAshape2[ph1_chrid][0];
    }
    if(last==2)
    {
            if (offset<= ph2_DNAshape1[ph1_chrid][last-1] && offset > ph2_DNAshape1[ph1_chrid][last-2])
            {
             update[1]=ph2_DNAshape2[ph1_chrid][last-1]-ph2_DNAshape1[ph1_chrid][last-2];
             return ph2_DNAshape2[ph1_chrid][last-1]-ph2_DNAshape1[ph1_chrid][last-2];
            }
            else{
                update[1]=ph2_DNAshape2[ph1_chrid][last-2];
                return ph2_DNAshape2[ph1_chrid][last-2];
            }
    }
    while(first <= last)
    {
        mid = first + (last-first)/2;
       // cout<<"mid\t"<<mid<<endl;
        if (offset<= ph2_DNAshape1[ph1_chrid][mid-1] && offset > ph2_DNAshape1[ph1_chrid][mid-2])
            {
            //cout<<"mid\t"<<mid<<endl;
            update[1]=ph2_DNAshape2[ph1_chrid][mid-1]-ph2_DNAshape1[ph1_chrid][mid-2];
             return ph2_DNAshape2[ph1_chrid][mid-1]-ph2_DNAshape1[ph1_chrid][mid-2];
            }

        else if (ph2_DNAshape1[ph1_chrid][mid-1] < offset)
            {
            first = mid+1;
            }

        else
            {
            last = mid-1;
                if(last==1)
                {
                    update[1]=ph2_DNAshape2[ph1_chrid][0];
                    return ph2_DNAshape2[ph1_chrid][0];
                }
            }
        }

}


const vector<string>& return_ph2_chrlist()
{
    return Chr_list_reindex;
}




const vector<vector <int> >&  return_ph2_DNAshape1()
{
    return ph2_DNAshape1;
}


const vector<vector <int> >&  return_ph2_DNAshape2()
{
    return ph2_DNAshape2;
}


void return_phase2_DNAshape()
{
    send_ph2_DNAshape(ph2_DNAshape1, ph2_DNAshape2);

}
