        #include<vector>
        #include<iostream>
        #include <math.h>
        #include <boost/math/distributions/poisson.hpp>
        #include "EM_algo.h"
        #include "EM_algorithm.h"
        #include "maskDNA.h"
        #include <bitset>
        #include "ebwt_search.h"
        #include<queue>
        #include <fstream>


        const uint8_t *watson_strand;
        const uint8_t *crick_strand;
        const uint8_t *watson_strand_control;
        const uint8_t *crick_strand_control;
        vector<vector <int> > phase2_DNAshape1;
        vector<vector <int> > phase2_DNAshape2;
        vector <int> DNA_size;
        vector<string> Chrm;
        double ControlChIPScale=1;
        int totalChIPNonRedudantReads=0;
        int totalControlNonRedudantReads=0;
        int PileupAtPeak=0;
        int controlExtsize=0;
        uint64_t effGenomeSize;
        float logPvalue;
        float lambda_bkg;
        uint64_t SpeciesGenomeSize(char *genome){
        if (genome == "hs") return 2700000000;
        if (genome == "mm") return 1870000000;
        if (genome == "ce") return 90000000;
        if (genome == "dm") return 120000000;
        }

        double POISSON_cdf(double k, double lambda )
        {
            boost::math::poisson_distribution<> poisson(lambda);
            return(cdf(complement(poisson, k)));

        }

         void send_tags(const uint8_t *tags_watson, const uint8_t *tags_crick, const uint8_t *tags_watson_control, const uint8_t *tags_crick_control, vector <int>& DNAshape, vector<string>& Chr_list,float ChIPControlScale, int n)
        {
            int count_watson=0;
            int count_crick=0;
            int count_watson_control=0;
            int count_crick_control=0;
            watson_strand=tags_watson;
            crick_strand=tags_crick;
            watson_strand_control=tags_watson_control;
            crick_strand_control=tags_crick_control;
            DNA_size=DNAshape;
            Chrm=Chr_list;
            if(controlFile!=NULL){
            ControlChIPScale=ChIPControlScale;
            for (int i=0; i<n; i++){
            count_watson=count_watson+ LookUptable[watson_strand[i]];
            count_crick=count_crick+ LookUptable[crick_strand[i]];
            count_watson_control=count_watson_control+ LookUptable[watson_strand_control[i]];
            count_crick_control=count_crick_control+ LookUptable[crick_strand_control[i]];
            }
            totalChIPNonRedudantReads=count_crick+count_watson;
            totalControlNonRedudantReads=count_crick_control+count_watson_control;
            //cout<<"totalChIPNonRedudantReads\t"<<totalChIPNonRedudantReads<<endl;
            //cout<<"totalControlNonRedudantReads\t"<<totalControlNonRedudantReads<<endl;

            }
            else{
            ControlChIPScale=1;
            for (int i=0; i<n; i++){
            count_watson=count_watson+ LookUptable[watson_strand[i]];
            count_crick=count_crick+ LookUptable[crick_strand[i]];
            }
            totalChIPNonRedudantReads=count_crick+count_watson;
            //cout<<"totalChIPNonRedudantReads\t"<<totalChIPNonRedudantReads<<endl;
            }
            if(frag_len%2==0){
            controlExtsize=frag_len/2;
            }
            else{
            controlExtsize=(frag_len/2) +1;
            }

            effGenomeSize=SpeciesGenomeSize(genome);
            //cout<<effGenomeSize<<"\teffGenomeSize"<<endl;
            logPvalue=-1*log10(pValue);

            if(controlFile!=NULL){
                if(ControlChIPScale>1){
                    lambda_bkg= float(totalChIPNonRedudantReads)*(float(frag_len)/effGenomeSize)/ControlChIPScale;
                }
                else{
                    //cout<<"totalChIPNotRedundants\t"<<totalChIPNonRedudantReads<<endl;
                    //cout<<"effgenome\t"<<effGenomeSize<<endl;
                    //cout<<"frag_len\t"<<frag_len<<endl;
                    lambda_bkg= float(totalChIPNonRedudantReads)*float(frag_len)/effGenomeSize;
                    //cout<<"lambda_bkg\t"<<lambda_bkg<<endl;
                }
                }
                else{
                    lambda_bkg= float(totalChIPNonRedudantReads)*float(frag_len)/effGenomeSize;
                }

          }

        void send_ph2_DNAshape(vector<vector <int> >& ph2_DNAshape1, vector<vector <int> >& ph2_DNAshape2)
        {
            phase2_DNAshape1=ph2_DNAshape1;
            phase2_DNAshape2=ph2_DNAshape2;
        }


        void pileup(ofstream& peaks, const uint8_t *tags_watson, const uint8_t *tags_crick, const uint8_t *tags_watson_control, const uint8_t *tags_crick_control, int len, int start, string chr, int p)
        {
            uint16_t *pileup_array;
            float    *pileup_array_d;
            uint16_t *pileup_array_1k;
            uint16_t *pileup_array_5k;
            uint16_t *pileup_array_10k;
            float    *ControlLambda;
            double   *pValueArray;
            uint16_t *pileup_array_watson;
            uint16_t *pileup_array_crick;
            uint16_t *pileup_array_watson_frag;
            uint16_t *pileup_array_crick_frag;

            pileup_array=new uint16_t[len+2*frag_len]();
            vector<float> smoothed_pileup_array;

            for(int i=0; i<len/8;i++)
            {
                if(int(tags_watson[i])>0)
                {
                    uint8_t mask=128;
                    for (int j=0; j<8;j++)
                    {
                        if((tags_watson[i]&mask)!=0)
                        {
                            int pos=i*8+j;
                            for(int k= pos+frag_len; k<=pos+2*frag_len;k++)
                            {
                                pileup_array[k]+=1;
                            }
                        }
                        mask>>=1;
                    }
                }
                if(int(tags_crick[i])>0)
                {
                    uint8_t mask=128;
                    for (int j=0; j<8;j++)
                    {
                        if((tags_crick[i]&mask)!=0)
                        {
                            int pos=i*8+j;
                            for(int k= pos+READ_LEN; k<=pos+READ_LEN+frag_len ;k++)
                            {
                            pileup_array[k]+=1;
                            //pileup_array_crick_frag[k]+=1;
                            }
                    }
                    mask>>=1;
                    }
                }
            }


            if(controlFile!=NULL)
            {
                pileup_array_d=new float[len+2*frag_len]();

            //krishna: d/2 extension
                for(int i=0; i<len/8;i++)
                {
                    if(int(tags_watson_control[i])>0)
                    {
                    uint8_t mask=128;
                    for (int j=0; j<8;j++)
                    {
                    if((tags_watson_control[i]&mask)!=0)
                    {
                        int pos=i*8+j;
                        for(int k= pos+frag_len-controlExtsize; k<=pos+frag_len+controlExtsize;k++)
                        {
                        pileup_array_d[k]+=1;
                        }
                    }
                mask>>=1;
                }
                }
                if(int(tags_crick_control[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_crick_control[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+frag_len+controlExtsize+READ_LEN; k>=pos+frag_len-controlExtsize+ READ_LEN ;k--)
                    {
                        pileup_array_d[k]+=1;
                    }
                    }
                mask>>=1;
                }
                }
                }

            pileup_array_1k=new uint16_t[len+2*1000]();
        //krishna: 1k extension
          for(int i=0; i<len/8;i++)
            {
                if(int(tags_watson_control[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_watson_control[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+1000-500; k<=pos+1000+500;k++)
                    {
                        pileup_array_1k[k]+=1;
                    }
                   }
                mask>>=1;
                }
                }
                if(int(tags_crick_control[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_crick_control[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+1000+500+READ_LEN; k>=pos+1000-500+READ_LEN ;k--)
                    {
                        pileup_array_1k[k]+=1;
                    }
                    }
                mask>>=1;
                }
                }
            }

            for(int i =0; i<len+2*frag_len; i++){
            if(pileup_array_d[i]<float(pileup_array_1k[i+1000-frag_len])*(float(frag_len)/1000)){
                pileup_array_d[i]=float(pileup_array_1k[i+1000-frag_len])*(float(frag_len)/1000);
            }
        }
            delete[] pileup_array_1k;
            pileup_array_10k=new uint16_t[len+2*10000]();

            //krishna: 10k extension
          for(int i=0; i<len/8;i++)
            {
                if(int(tags_watson_control[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_watson_control[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+10000-5000; k<=pos+10000+5000;k++)
                    {
                        pileup_array_10k[k]+=1;
                    }
                   }
                mask>>=1;
                }
                }
                if(int(tags_crick_control[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_crick_control[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+10000+5000+READ_LEN; k>=pos+10000-5000+READ_LEN ;k--)
                    {
                        pileup_array_10k[k]+=1;
                    }
                    }
                mask>>=1;
                }
                }
            }

            for(int i =0; i<len+2*frag_len; i++){
            if(pileup_array_d[i]<float(pileup_array_10k[i+10000-frag_len])*(float(frag_len)/10000)){
                pileup_array_d[i]=float(pileup_array_10k[i+10000-frag_len])*(float(frag_len)/10000);
            }
            }
            delete[] pileup_array_10k;

            }
            else
            {
            pileup_array_d=new float[len+2*frag_len]();


        pileup_array_5k=new uint16_t[len+2*5000]();
        //krishna: 5k extension
          for(int i=0; i<len/8;i++)
            {
                if(int(tags_watson[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_watson[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+5000-2500; k<=pos+5000+2500;k++)
                    {
                        pileup_array_5k[k]+=1;
                    }
                   }
                mask>>=1;
                }
                }
                if(int(tags_crick[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_crick[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+5000+2500+READ_LEN; k>=pos+5000-2500+READ_LEN ;k--)
                    {
                        pileup_array_5k[k]+=1;
                    }
                    }
                mask>>=1;
                }
                }
            }
        for(int i =0; i<len+2*frag_len; i++){
            if(pileup_array_d[i]<float(pileup_array_5k[i+5000-frag_len])*(float(frag_len)/5000)){
                pileup_array_d[i]=float(pileup_array_5k[i+5000-frag_len])*(float(frag_len)/5000);
            }
            }
            delete[] pileup_array_5k;
          pileup_array_10k=new uint16_t[len+2*10000]();
            //krishna: 10k extension
          for(int i=0; i<len/8;i++)
            {
                if(int(tags_watson[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_watson[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+10000-5000; k<=pos+10000+5000;k++)
                    {
                        pileup_array_10k[k]+=1;
                    }
                   }
                mask>>=1;
                }
                }
                if(int(tags_crick[i])>0)
                {
                uint8_t mask=128;
                for (int j=0; j<8;j++)
                {
                if((tags_crick[i]&mask)!=0)
                    {
                    int pos=i*8+j;
                    for(int k= pos+10000+5000+READ_LEN; k>=pos+10000-5000+READ_LEN ;k--)
                    {
                        pileup_array_10k[k]+=1;
                    }
                    }
                mask>>=1;
                }
                }
            }

            for(int i =0; i<len+2*frag_len; i++){
            if(pileup_array_d[i]<float(pileup_array_10k[i+10000-frag_len])*(float(frag_len)/10000)){
                pileup_array_d[i]=float(pileup_array_10k[i+10000-frag_len])*(float(frag_len)/10000);
            }
            }
            delete[] pileup_array_10k;

            }

                ControlLambda=new float[len+2*frag_len]();
                pValueArray=new double[len+2*frag_len]();


                if(controlFile!=NULL){
                    if(ControlChIPScale<1){
                        for(int i =0; i<len+2*frag_len; i++){
                            if(float(pileup_array_d[i])*ControlChIPScale < lambda_bkg){
                                ControlLambda[i]=lambda_bkg;
                                }
                            else{
                            ControlLambda[i]=float(pileup_array_d[i])*ControlChIPScale;
                                }
                     pValueArray[i]=POISSON_cdf(int(pileup_array[i]), ControlLambda[i]);

                }}
                else{
                for(int i =0; i<len+2*frag_len; i++){
                    if(float(pileup_array_d[i])< lambda_bkg){
                    ControlLambda[i]=lambda_bkg;
                    }
                    else{
                            ControlLambda[i]=float(pileup_array_d[i]);
                        }
                     pValueArray[i]=POISSON_cdf(int(pileup_array[i]/ControlChIPScale), ControlLambda[i]);

                    }
                    }
                }
                else{
                for(int i =0; i<len+2*frag_len; i++){
                if(pileup_array_d[i] < lambda_bkg){
                    ControlLambda[i]=lambda_bkg;
                }
                else{

                    ControlLambda[i]=float(pileup_array_d[i]);
                }
                     pValueArray[i]=POISSON_cdf(int(pileup_array[i]), ControlLambda[i]);

                }
                }
                delete[] ControlLambda;
                delete[] pileup_array_d;

                    float sum=0;
                    int window=frag_len/4;
                    for(int i= 0; i<len+2*frag_len;i++)
                    {
                            sum+=pileup_array[i];
                            if(i+1 > window)
                            {
                            smoothed_pileup_array.push_back(sum/window);
                            sum=sum-pileup_array[(i+1)-window];
                            }
                    }

                    int found_increase=0;
                    int found_decrease=0;
                    queue<int> peak_locs;
                    int previous_peak_loc=0;
                    for(int i= 0; i<smoothed_pileup_array.size()-1;i++)
                    {

                        if(smoothed_pileup_array[i+1]>smoothed_pileup_array[i])
                        {
                            if(found_decrease==1)
                            {
                            found_increase=2;
                            }
                            else
                            {
                            found_increase=1;
                            }
                        }
                        if(smoothed_pileup_array[i+1]<smoothed_pileup_array[i])
                        {
                            if(found_increase==1)
                            {
                            found_decrease=2;
                            }
                            else
                            {
                            found_decrease=1;
                            }
                        }

                        if(found_increase==1 && found_decrease==2 && smoothed_pileup_array[i]>=3)
                        {

                            found_increase=0;
                            found_decrease=0;
                            if(previous_peak_loc!=0)
                            {

                                if(i-previous_peak_loc > frag_len)
                                {
                                peak_locs.push(previous_peak_loc+window/2);
                                previous_peak_loc=i;
                                }
                                else
                                {
                                    if(smoothed_pileup_array[previous_peak_loc] < smoothed_pileup_array[i])
                                    {
                                    previous_peak_loc=i;
                                    }
                                }
                            }
                            else
                            {
                                previous_peak_loc=i;
                            }
                        }

                        if(found_increase== 2 && found_decrease==1)
                        {
                            found_increase=0;
                            found_decrease=0;
                        }

                        if(i==smoothed_pileup_array.size()-2)
                        {
                            peak_locs.push(previous_peak_loc+window/2);
                        }

                    }


                    int peak_pileup=0;
                    float peak_location=0;
                    int peak_start=0;
                    int peak_end=0;
                    int count =0;
                    int old_peak_end=0;

                    int number_of_peaks=peak_locs.size();

                    while(!peak_locs.empty())
                    {
                        peak_location=peak_locs.front();

                        if(peak_location+start-frag_len<=old_peak_end)
                        {
                          peak_locs.pop();
                          continue;
                        }

                    PileupAtPeak=int(pileup_array[int(peak_location)]);
                    if(PileupAtPeak>0 && pValueArray[int(peak_location)]<pValue)
                    {
                        bool found_start=false;
                        bool found_end=false;
                        bool found=false;
                        int i=int(peak_location);
                        float peak_start_location;
                        float  peak_end_location;
                        int peak_watson=0;
                        int peak_crick=0;
                        count=0;
                        while(found_start!=true) {
                        if(-1.00*log10(pValueArray[i])<logPvalue){
                        found_start=true;
                        found=true;
                        peak_start_location=i;
                        }
                            i=i-1;
                        }
                        if(found_start==true && peak_start_location >=1){
                         while(found==true && peak_start_location>=0){
                         found=false;
                         for(int j=int(peak_start_location)-1; j>=max((int(peak_start_location)-READ_LEN),0); j--){
                          if(-1.00*log10(pValueArray[j])>=logPvalue){
                           peak_start_location=j;
                           found=true;
                          }
                         }
                         }

                        }
                        i=int(peak_location);
                        found=false;

                        while(found_end!=true){
                        if(-1.00*log10(pValueArray[i])<logPvalue){
                        found_end=true;
                        found=true;
                        peak_end_location=i;
                        }
                        i=i+1;
                        }

                      if(found_end==true){
                         while(found==true && peak_end_location<len+2*frag_len){
                         found=false;
                         for(int j=int(peak_end_location)+1; j<= max((int(peak_end_location)+READ_LEN), len+2*frag_len-1); j++){
                          if(-1.00*log10(pValueArray[j])>=logPvalue){
                           peak_end_location=j;
                           found=true;
                          }
                         }
                         }
                        }

                        if(int(peak_end_location)-int(peak_start_location)>=frag_len)
                        {
                         if(old_peak_end>=int(peak_start_location)+start-frag_len)
                         {
                            peak_start_location= old_peak_end+frag_len-start+1;
                         }
                        peaks<<chr<<"\t"<<max(int(peak_start_location)+start-frag_len,0)<<"\t"<<int(peak_end_location)+start-frag_len<<"\t"<<int(peak_end_location)-int(peak_start_location)
                        <<"\t"<<int(pileup_array[int(peak_location)])<<"\t"<<int(peak_location)+start-frag_len<<"\t"<<std::fixed<<std::setprecision(2)<<-1*log10(pValueArray[int(peak_location)])<<endl;
                        old_peak_end=int(peak_end_location)+start-frag_len;
                        }

                    }
                    peak_locs.pop();
                    }


            if(controlFile!=NULL){
            delete[] pileup_array;
            delete[] pValueArray;
            }
            else{
            delete[] pileup_array;
            delete[] pValueArray;
            }

        }



        void callpeaks()
        {
            cerr<<endl<<"Phase 5: Performing peak calling"<<endl;
            ofstream peaks;
            if(peakFile==NULL){
            peaks.open("Peaks.bed");
            }
            else{
            peaks.open(strcat(peakFile,"Peaks.bed"));
            }
            peaks<<"Number of reads: "<<NUM_OF_READS<<endl;
            peaks<<"EM cutoff: "<<emCutoff<<endl;
            peaks<<"Island Threshold: "<<islandTres<<endl;
            peaks<<"p.value: "<<pValue<<endl;
            peaks<<"Estimated Fragment Length: "<<frag_len<<endl;
            if(controlFile==NULL){
            peaks<<"# of ChIP non redundant reads: "<<totalChIPNonRedudantReads<<endl;
            }
            else{
            peaks<<"# of ChIP non redundant reads: "<<totalChIPNonRedudantReads<<endl;
            peaks<<"# of control non redundant reads: "<<totalControlNonRedudantReads<<endl;
            peaks<<"ChIP to control scaling factor: "<<ControlChIPScale<<endl;
            }

            peaks<<"Chr\t"<<"Start\t"<<"End\t"<<"Length\t"<<"Pileup\t"<<"Summit\t"<<"-log10(p.value)\t"
                 <<"local lambda"<<endl;
            //cout<<phase2_DNAshape1[i].size()<<endl;
                for (int i=0; i<phase2_DNAshape1.size(); i++)
                {
                    if(phase2_DNAshape1[i].size()!=0)
                    {
                        for(int j=0;j<phase2_DNAshape1[i].size();j++)
                        {
                                int start= phase2_DNAshape2[i][j]/8;
                                int end=(phase2_DNAshape1[i][j]+phase2_DNAshape2[i][j])/8;
                                int len;
                                if(j==0)
                                {
                                    len=phase2_DNAshape1[i][j];
                                }
                                else
                                {
                                    len=phase2_DNAshape1[i][j]-phase2_DNAshape1[i][j-1];
                                }

                                int p=0;
                                if(i==0)
                                {
                                    p=start;
                                    if(controlFile!=NULL){
                                    pileup(peaks, watson_strand + p, crick_strand+p, watson_strand_control + p, crick_strand_control+p, len,phase2_DNAshape2[i][j], Chrm[i],p);
                                    }
                                    else{
                                    pileup(peaks, watson_strand + p, crick_strand+p, NULL, NULL, len,phase2_DNAshape2[i][j], Chrm[i],p);
                                    }

                                }
                                else{
                                    p= start+DNA_size[i-1];
                                    //pileup(peaks, watson_strand + p, crick_strand+p, watson_strand_control + p, crick_strand_control+p, len,phase2_DNAshape2[i][j], Chrm[i],p);
                                    if(controlFile!=NULL){
                                    pileup(peaks, watson_strand + p, crick_strand+p, watson_strand_control + p, crick_strand_control+p, len,phase2_DNAshape2[i][j], Chrm[i],p);
                                    }
                                    else{
                                    pileup(peaks, watson_strand + p, crick_strand+p, NULL, NULL, len,phase2_DNAshape2[i][j], Chrm[i],p);
                                    }

                                }

                        }
                    }

                }

                peaks.close();



        }






